//
// Created by beerpsi on 12/31/2023.
//

#ifndef CHUNIIO_BROKENITHM_ANDROID_H
#define CHUNIIO_BROKENITHM_ANDROID_H

#define WIN32_LEAN_AND_MEAN
#include <windows.h>

#include "ipc_memory_info.h"

;
#pragma pack(push)
#pragma pack(1)
struct AndroidPacketInput {
    uint8_t packetSize;
    uint8_t packetName[3];
    uint32_t packetId;
    uint8_t airIoStatus[6];
    uint8_t sliderIoStatus[32];
    uint8_t testBtn;
    uint8_t serviceBtn;
};

struct PacketInputNoAir {
    uint8_t packetSize;
    uint8_t packetName[3];
    uint32_t packetId;
    uint8_t sliderIoStatus[32];
    uint8_t testBtn;
    uint8_t serviceBtn;
};

struct PacketConnect {
    uint8_t packetSize;
    uint8_t packetName[3];
    uint8_t addrType;
    uint16_t port;
    union {
        struct {
            uint8_t addr[4];
            uint8_t padding[12];
        } addr4;
        uint8_t addr6[16];
    } addr;
};

struct PacketCard {
    uint8_t packetSize;
    uint8_t packetName[3];
    uint8_t remoteCardRead;
    uint8_t remoteCardType;
    uint8_t remoteCardId[10];
};

struct PacketPing {
    uint8_t packetSize;
    uint8_t packetName[3];
    uint64_t remotePingTime;
};
#pragma pack(pop)

HRESULT android_init_server(struct IPCMemoryInfo *memory);

#endif // CHUNIIO_BROKENITHM_ANDROID_H
